/***********************************************************************
 *      This example program is an excerpt from the book:              *
 *                                                                     *
 *          X Window OSF/Motif Toolkit Programming (I)                 *
 *            - Programming Basics, Resource and Event -               *
 *                                                                     *
 *      Copyright 1994, Hideyuki Hayashi                               *
 *                                                                     *
 *      This program can be distributed without fee, provided          *
 *      that the above copyright notice appear in all copies.          *
 ***********************************************************************/

#include <Xm/XmAll.h>

static void ButtonCB();

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget  toplevel, rowcol, button;
    Arg     al[20];
    int     ac;
    XPoint  *point = (XPoint*)XtMalloc(sizeof(XPoint));
    point->x = 50;   /* Data passed to callback function */
    point->y = 30;

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Passudatares", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    rowcol = XmCreateRowColumn(toplevel, "rowcol", al, ac);
    XtManageChild(rowcol);

    ac = 0;          /* VVVVVV Pass a user data resource */
    XtSetArg(al[ac], XmNuserData, point); ac++;
    button = XmCreatePushButton(rowcol, "button", al, ac);
    XtManageChild(button);
    /* Register callback function */
    XtAddCallback(button, XmNactivateCallback, ButtonCB, NULL);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

static void ButtonCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    XPoint *point;
                     /* VVVVVV     VVVVVV Retrieve the user data resource */
    XtVaGetValues(w, XmNuserData, &point, NULL);

    printf("Passed point: (%d,%d)\n", point->x, point->y);
}

